/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of pogl_gl_top.xs. Do not edit this file, edit pogl_gl_top.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "pogl_gl_top.xs"
/*  Last saved: Sun 27 Sep 2009 10:20:35 PM*/

/*  Copyright (c) 1998 Kenneth Albanowski. All rights reserved.
 *  Copyright (c) 2007 Bob Free. All rights reserved.
 *  Copyright (c) 2009 Chris Marshall. All rights reserved.
 *  This program is free software; you can redistribute it and/or
 *  modify it under the same terms as Perl itself.
 */

/* OpenGL GLX bindings */
#define IN_POGL_GLX_XS

#include <stdio.h>

#include "pgopogl.h"

#ifdef HAVE_GL
#include "gl_util.h"

/* Note: this is caching procs once for all contexts */
/* !!! This should instead cache per context */
#if defined(_WIN32) || (defined(__CYGWIN__) && defined(HAVE_W32API))
#define loadProc(proc,name) \
{ \
  if (!proc) \
  { \
    proc = (void *)wglGetProcAddress(name); \
    if (!proc) croak(name " is not supported by this renderer"); \
  } \
}
#define testProc(proc,name) ((proc) ? 1 : !!(proc = (void *)wglGetProcAddress(name)))
#else /* not using WGL */
#define loadProc(proc,name)
#define testProc(proc,name) 1
#endif /* not defined _WIN32, __CYGWIN__, and HAVE_W32API */
#endif /* defined HAVE_GL */

#ifdef HAVE_GLX
#include "glx_util.h"
#endif /* defined HAVE_GLX */

#ifdef HAVE_GLU
#include "glu_util.h"
#endif /* defined HAVE_GLU */



#ifdef IN_POGL_GLX_XS
#ifdef HAVE_GLX
#  define HAVE_GLpc			/* Perl interface */
#  define nativeWindowId(d, w)	(w)
static Bool WaitForNotify(Display *d, XEvent *e, char *arg) {
    return (e->type == MapNotify) && (e->xmap.window == (Window)arg);
}
#  define glpResizeWindow(s1,s2,w,d)	XResizeWindow(d,w,s1,s2)
#  define glpMoveWindow(s1,s2,w,d)		XMoveWindow(d,w,s1,s2)
#  define glpMoveResizeWindow(s1,s2,s3,s4,w,d)	XMoveResizeWindow(d,w,s1,s2,s3,s4)
#endif	/* defined HAVE_GLX */ 


#ifdef __PM__

#  define HAVE_GLpc			/* Perl interface */
#  define auxXWindow()	(croak("Not implemented: auxXWindow"),0)

HMQ hmq;
AV *EventAv;
unsigned long LastEventMask;	/* !! Common for all the windows */
Display myDisplay;

#endif	/* defined __PM__ */ 

static int debug = 0;

#ifdef HAVE_GLpc

#  define NUM_ARG 7			/* Number of mandatory args to glpcOpenWindow */

Display *dpy;
int dpy_open;
XVisualInfo *vi;
Colormap cmap;
XSetWindowAttributes swa;
Window win;
GLXContext ctx;

static int default_attributes[] = { GLX_DOUBLEBUFFER, GLX_RGBA, None };

#endif	/* defined HAVE_GLpc */ 

static int DBUFFER_HACK = 0;
#define __had_dbuffer_hack() (DBUFFER_HACK)

#endif /* End IN_POGL_GLX_XS */



/********************/
/* GPGPU Utils      */
/********************/

GLint FBO_MAX = -1;

/* Get max GPGPU data size */
int gpgpu_size(void)
{
#if defined(GL_ARB_texture_rectangle) && defined(GL_ARB_texture_float) && \
  defined(GL_ARB_fragment_program) && defined(GL_EXT_framebuffer_object)
  if (FBO_MAX == -1)
  {
    if (testProc(glProgramStringARB,"glProgramStringARB") &&
      testProc(glGenProgramsARB,"glGenProgramsARB") &&
      testProc(glBindProgramARB,"glBindProgramARB") &&
      testProc(glIsProgramARB,"glIsProgramARB") &&
      testProc(glProgramLocalParameter4fvARB,"glProgramLocalParameter4fvARB") &&
      testProc(glDeleteProgramsARB,"glDeleteProgramsARB") &&
      testProc(glGenFramebuffersEXT,"glGenFramebuffersEXT") &&
      testProc(glGenRenderbuffersEXT,"glGenRenderbuffersEXT") &&
      testProc(glBindFramebufferEXT,"glBindFramebufferEXT") &&
      testProc(glFramebufferTexture2DEXT,"glFramebufferTexture2DEXT") &&
      testProc(glBindRenderbufferEXT,"glBindRenderbufferEXT") &&
      testProc(glRenderbufferStorageEXT,"glRenderbufferStorageEXT") &&
      testProc(glFramebufferRenderbufferEXT,"glFramebufferRenderbufferEXT") &&
      testProc(glCheckFramebufferStatusEXT,"glCheckFramebufferStatusEXT") &&
      testProc(glDeleteRenderbuffersEXT,"glDeleteRenderbuffersEXT") &&
      testProc(glDeleteFramebuffersEXT,"glDeleteFramebuffersEXT"))
    {
      glGetIntegerv(GL_MAX_RENDERBUFFER_SIZE_EXT,&FBO_MAX);
    }
    else
    {
      FBO_MAX = 0;
    }
  }
  return(FBO_MAX);
#else
  return(0);
#endif
}

/* Get max square array width for a given GPGPU data size */
int gpgpu_width(int len)
{
  int max = gpgpu_size();
  if (max && len && !(len%3))
  {
    int count = len / 3;
    int w = (int)sqrt(count);

    while ((w <= count) && (w <= max))
    {
      if (!(count%w)) return(w);
      w++;
    }
  }
  return(0);
}

#ifdef GL_ARB_fragment_program
static char affine_prog[] =
  "!!ARBfp1.0\n"
  "PARAM affine[4] = {program.local[0..3]};\n"
  "TEMP decal;\n"
  "TEX decal, fragment.texcoord[0], texture[0], RECT;\n"
  "MOV decal.w, 1.0;\n"
  "DP4 result.color.x, decal, affine[0];\n"
  "DP4 result.color.y, decal, affine[1];\n"
  "DP4 result.color.z, decal, affine[2];\n"
  "END\n";

/* Enable affine shader program */
void enable_affine(oga_struct * oga)
{
  if (!oga) return;
  if (!oga->affine_handle)
  {
    /* Load shader program */
    glGenProgramsARB(1,&oga->affine_handle);
    glBindProgramARB(GL_FRAGMENT_PROGRAM_ARB,oga->affine_handle);
    glProgramStringARB(GL_FRAGMENT_PROGRAM_ARB,
      GL_PROGRAM_FORMAT_ASCII_ARB, strlen(affine_prog),affine_prog);

    /* Validate shader program */
    if (!glIsProgramARB(oga->affine_handle))
    {
      GLint errorPos;
      glGetIntegerv(GL_PROGRAM_ERROR_POSITION_ARB,&errorPos);
      if (errorPos < 0) errorPos = strlen(affine_prog);
      croak("Affine fragment program error\n%s",&affine_prog[errorPos]);
    }
  }
  glEnable(GL_FRAGMENT_PROGRAM_ARB);
}

/* Disable affine shader program */
void disable_affine(oga_struct * oga)
{
  if (!oga) return;
  if (oga->affine_handle) glDisable(GL_FRAGMENT_PROGRAM_ARB);
}
#endif

#ifdef GL_EXT_framebuffer_object
/* Unbind an FBO to an OGA */
void release_fbo(oga_struct * oga)
{
  if (oga->fbo_handle)
  {
    glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
    glDeleteFramebuffersEXT(1,&oga->fbo_handle);
  }

  if (oga->tex_handle)
  {
    glBindTexture(oga->target,0);	
    if (oga->tex_handle[0]) glDeleteTextures(1,&oga->tex_handle[0]);
    if (oga->tex_handle[1]) glDeleteTextures(1,&oga->tex_handle[1]);
  }
}

/* Enable an FBO bound to an OGA */
void enable_fbo(oga_struct * oga, int w, int h, GLuint target,
  GLuint pixel_type, GLuint pixel_format, GLuint element_size)
{
  if (!oga) return;

  if ((oga->fbo_w != w) || (oga->fbo_h != h) ||
    (oga->target != target) ||
    (oga->pixel_type != pixel_type) ||
    (oga->pixel_format != pixel_format) ||
    (oga->element_size != element_size)) release_fbo(oga);

  if (!oga->fbo_handle)
  {
    GLenum status;

    /* Save params */
    oga->fbo_w = w;
    oga->fbo_h = h;
    oga->target = target;
    oga->pixel_type = pixel_type;
    oga->pixel_format = pixel_format;
    oga->element_size = element_size;

    /* Set up FBO */
    glGenTextures(2,oga->tex_handle);
    glGenFramebuffersEXT(1,&oga->fbo_handle);
    glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,oga->fbo_handle);

    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0,w,0,h);
    glMatrixMode(GL_MODELVIEW); 
    glLoadIdentity();

    glBindTexture(target,oga->tex_handle[1]);
    glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
    glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
    glTexParameteri(target,GL_TEXTURE_WRAP_S,GL_CLAMP);
    glTexParameteri(target,GL_TEXTURE_WRAP_T,GL_CLAMP);

    glTexImage2D(target,0,pixel_type,w,h,0,
      pixel_format,element_size,0);

    glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,
      GL_COLOR_ATTACHMENT0_EXT,target,oga->tex_handle[1],0);

    status = glCheckFramebufferStatusEXT(GL_RENDERBUFFER_EXT);
    if (status) croak("enable_fbo status: %04X\n",status);
  }
  else
  {
    glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,oga->fbo_handle);
  }

  /* Load data */
  glBindTexture(target,oga->tex_handle[0]);
  glTexImage2D(target,0,pixel_type,w,h,0,
    pixel_format,element_size,oga->data);

  glEnable(target);
  //glDrawBuffer(GL_COLOR_ATTACHMENT0_EXT);
  glBindTexture(target,oga->tex_handle[0]);
  glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);
}

/* Disable an FBO bound to an OGA */
void disable_fbo(oga_struct * oga)
{
  if (!oga) return;
  if (oga->fbo_handle)
  {
    glDisable(oga->target);
    glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,0);
  }
}
#endif




#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 317 "pogl_gl_top.c"

XS(XS_OpenGL__have_gl); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL__have_gl)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::_have_gl", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 311 "pogl_gl_top.xs"
#ifdef HAVE_GL
	RETVAL = 1;
#else
	RETVAL = 0;
#endif /* defined HAVE_GL */
#line 339 "pogl_gl_top.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenGL__have_glu); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL__have_glu)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::_have_glu", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 323 "pogl_gl_top.xs"
#ifdef HAVE_GLU
	RETVAL = 1;
#else
	RETVAL = 0;
#endif /* defined HAVE_GLU */
#line 366 "pogl_gl_top.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenGL__have_glut); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL__have_glut)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::_have_glut", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 335 "pogl_gl_top.xs"
#if defined(HAVE_GLUT) || defined(HAVE_FREEGLUT)
	RETVAL = 1;
#else
	RETVAL = 0;
#endif /* defined HAVE_GLUT or HAVE_FREEGLUT */
#line 393 "pogl_gl_top.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenGL__have_freeglut); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL__have_freeglut)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::_have_freeglut", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 347 "pogl_gl_top.xs"
#if defined(HAVE_FREEGLUT)
	RETVAL = 1;
#else
	RETVAL = 0;
#endif /* defined HAVE_FREEGLUT */
#line 420 "pogl_gl_top.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenGL__have_glx); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL__have_glx)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::_have_glx", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 359 "pogl_gl_top.xs"
#ifdef HAVE_GLX
	RETVAL = 1;
#else
	RETVAL = 0;
#endif /* defined HAVE_GLX */
#line 447 "pogl_gl_top.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenGL__have_glp); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL__have_glp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::_have_glp", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 371 "pogl_gl_top.xs"
#ifdef HAVE_GLpc
	RETVAL = 1;
#else
	RETVAL = 0;
#endif /* defined HAVE_GLpc */
#line 474 "pogl_gl_top.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef IN_POGL_GLX_XS
#ifdef __PM__
#define XSubPPtmpAAAA 1


XS(XS_OpenGL_morphPM); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_morphPM)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::morphPM", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {

	morphPM();
    }
    XSRETURN_EMPTY;
}

#endif
#define XSubPPtmpAAAB 1


XS(XS_OpenGL___had_dbuffer_hack); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL___had_dbuffer_hack)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::__had_dbuffer_hack", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = __had_dbuffer_hack();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef HAVE_GLpc			/* GLX or __PM__ */
#define XSubPPtmpAAAC 1


XS(XS_OpenGL_glpcOpenWindow); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpcOpenWindow)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 7)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpcOpenWindow", "x, y, w, h, pw, event_mask, steal, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	x = (int)SvIV(ST(0));
	int	y = (int)SvIV(ST(1));
	int	w = (int)SvIV(ST(2));
	int	h = (int)SvIV(ST(3));
	int	pw = (int)SvIV(ST(4));
	long	event_mask = (long)SvIV(ST(5));
	int	steal = (int)SvIV(ST(6));
	HV *	RETVAL;
#line 421 "pogl_gl_top.xs"
{
    XEvent event;
    Window pwin = (Window)pw;
    unsigned int err;
    int *attributes = default_attributes + 1;
    int *a_buf = NULL;

    RETVAL = newHV(); /* Create hash to return GL Object info */

    if(items > NUM_ARG){
        int i;
        a_buf = (int *) malloc((items-NUM_ARG+2) * sizeof(int));
        a_buf[0] = GLX_DOUBLEBUFFER; /* Preallocate */
        attributes = a_buf + 1;
        for (i=NUM_ARG; i<items; i++) {
            attributes[i-NUM_ARG] = SvIV(ST(i));
        }
        attributes[items-NUM_ARG] = None;
    }
    if (debug) {
        int i;	
        for (i=0; attributes[i] != None; i++) {
            printf("att=%d %d\n", i, attributes[i]);
        }
    }
    /* get a connection */
    if (!dpy_open) {
        dpy = XOpenDisplay(NULL);
        dpy_open = 1;
    }
    if (!dpy) {
        croak("ERROR: failed to get an X connection");
    } else if (debug) {
        printf("Display open %x\n", dpy);
    }		

    /* get an appropriate visual */
    vi = glXChooseVisual(dpy, DefaultScreen(dpy), attributes);
    if (!vi) { /* Might have happened that one does not
                * *need* DOUBLEBUFFER, but the display does
                * not provide SINGLEBUFFER; and the semantic
                * of GLX_DOUBLEBUFFER is that if it misses,
                * only SINGLEBUFFER visuals are selected.  */
        attributes--; /* GLX_DOUBLEBUFFER preallocated there */
        vi = glXChooseVisual(dpy, DefaultScreen(dpy), attributes); /* Retry */
        if (vi)
            DBUFFER_HACK = 1;
    }
    if (a_buf)
        free(a_buf);
    if(!vi) {
        croak("ERROR: failed to get an X visual\n");
    } else if (debug) {
        printf("Visual open %x\n", vi);
    }		

    /* A blank line here will confuse xsubpp ;-) */
#ifdef HAVE_GLX
    /* create a GLX context */
    ctx = glXCreateContext(dpy, vi, 0, GL_TRUE);
    if (!ctx) {
        croak("ERROR: failed to get an X Context");
    } else if (debug) {
        printf("Context Created %x\n", ctx);
    }

    /* create a color map */
    cmap = XCreateColormap(dpy, RootWindow(dpy, vi->screen),
            vi->visual, AllocNone);

    /* create a window */
    swa.colormap = cmap;
    swa.border_pixel = 0;
    swa.event_mask = event_mask;
#endif	/* defined HAVE_GLX */

    if (!pwin) {
        pwin = RootWindow(dpy, vi->screen);
        if (debug) printf("Using root as parent window 0x%x\n", pwin);
    }
    if (steal) {
        win = nativeWindowId(dpy, pwin); /* What about depth/visual */
    } else {
        win = XCreateWindow(dpy, pwin, 
                x, y, w, h,
                0, vi->depth, InputOutput, vi->visual,
                CWBorderPixel|CWColormap|CWEventMask, &swa);
        /* NOTE: PDL code had CWBackPixel above */
    }
    if (!win) {
        croak("No Window");
    } else {
        if (debug) printf("win = 0x%x\n", win);
    }
    XMapWindow(dpy, win);
#ifndef HAVE_GLX  /* For OS/2 GLX emulation stuff -chm 2009.09.14 */
    /* On OS/2: cannot create a context before mapping something... */
    /* create a GLX context */
    ctx = glXCreateContext(dpy, vi, 0, GL_TRUE);
    if (!ctx)
        croak("No context!\n");

    LastEventMask = event_mask;
#else	/* HAVE_GLX, this is the default branch */
    if ( (event_mask & StructureNotifyMask) && !steal ) {
        XIfEvent(dpy, &event, WaitForNotify, (char*)win);
    }
#endif	/* not defined HAVE_GLX */

    /* connect the context to the window */
    if (!glXMakeCurrent(dpy, win, ctx))
        croak("Non current");

    if (debug)
        printf("Display=0x%x Window=0x%x Context=0x%x\n",dpy, win, ctx);

    /* Create the GL object hash information */
    hv_store(RETVAL, "Display", strlen("Display"), newSViv(PTR2IV(dpy)), 0);
    hv_store(RETVAL, "Window", strlen("Window"),   newSViv(  (IV) win ), 0);
    hv_store(RETVAL, "Context", strlen("Context"), newSViv(PTR2IV(ctx)), 0);

    hv_store(RETVAL, "GL_Version",strlen("GL_Version"), 
            newSVpv((char *) glGetString(GL_VERSION),0),0);
    hv_store(RETVAL, "GL_Vendor",strlen("GL_Vendor"), 
            newSVpv((char *) glGetString(GL_VENDOR),0),0);
    hv_store(RETVAL, "GL_Renderer",strlen("GL_Renderer"), 
            newSVpv((char *) glGetString(GL_RENDERER),0),0);

    /* clear the buffer */
    glClearColor(0,0,0,1);
    while ( (err = glGetError()) != GL_NO_ERROR ) {
        printf("ERROR issued in GL %s\n", gluErrorString(err));
    }
}
#line 687 "pogl_gl_top.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_OpenGL_glpRasterFont); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpRasterFont)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpRasterFont", "name, base, number, d");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	name = (char *)SvPV_nolen(ST(0));
	int	base = (int)SvIV(ST(1));
	int	number = (int)SvIV(ST(2));
	Display *	d = INT2PTR(Display *,SvIV(ST(3)));
	int	RETVAL;
	dXSTARG;
#line 566 "pogl_gl_top.xs"
        {
                XFontStruct *fi;
                int lb;
                fi = XLoadQueryFont(d,name);
                if(fi == NULL) {
                        die("No font %s found",name);
                }
                lb = glGenLists(number);
                if(lb == 0) {
                        die("No display lists left for font %s (need %d)",name,number);
                }
                glXUseXFont(fi->fid, base, number, lb);
                RETVAL=lb;
        }
#line 728 "pogl_gl_top.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenGL_glpPrintString); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpPrintString)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpPrintString", "base, str");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	base = (int)SvIV(ST(0));
	char *	str = (char *)SvPV_nolen(ST(1));
#line 589 "pogl_gl_top.xs"
        {
                glPushAttrib(GL_LIST_BIT);
                glListBase(base);
                glCallLists(strlen(str),GL_UNSIGNED_BYTE,(GLubyte*)str);
                glPopAttrib();
        }
#line 756 "pogl_gl_top.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_OpenGL_glpDisplay); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpDisplay)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpDisplay", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	RETVAL;
	dXSTARG;
#line 600 "pogl_gl_top.xs"
	    /* get a connection */
	    if (!dpy_open) {
		dpy = XOpenDisplay(0);
		dpy_open = 1;
	    }
	    if (!dpy)
		croak("No display!");
	    RETVAL = dpy;
#line 785 "pogl_gl_top.c"
    }
    XSRETURN(1);
}


XS(XS_OpenGL_glpMoveResizeWindow); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpMoveResizeWindow)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpMoveResizeWindow", "x, y, width, height, w=win, d=dpy");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void*	d;
	GLXDrawable	w;
	int	x = (int)SvIV(ST(0));
	int	y = (int)SvIV(ST(1));
	unsigned int	width = (unsigned int)SvUV(ST(2));
	unsigned int	height = (unsigned int)SvUV(ST(3));

	if (items < 6)
	    d = dpy;
	else {
	    d = INT2PTR(void *,SvIV(ST(5)));
	}

	if (items < 5)
	    w = win;
	else {
	    w = INT2PTR(GLXDrawable,SvIV(ST(4)));
	}

	glpMoveResizeWindow(x, y, width, height, w, d);
    }
    XSRETURN_EMPTY;
}


XS(XS_OpenGL_glpMoveWindow); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpMoveWindow)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpMoveWindow", "x, y, w=win, d=dpy");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void*	d;
	GLXDrawable	w;
	int	x = (int)SvIV(ST(0));
	int	y = (int)SvIV(ST(1));

	if (items < 4)
	    d = dpy;
	else {
	    d = INT2PTR(void *,SvIV(ST(3)));
	}

	if (items < 3)
	    w = win;
	else {
	    w = INT2PTR(GLXDrawable,SvIV(ST(2)));
	}

	glpMoveWindow(x, y, w, d);
    }
    XSRETURN_EMPTY;
}


XS(XS_OpenGL_glpResizeWindow); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpResizeWindow)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpResizeWindow", "width, height, w=win, d=dpy");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void*	d;
	GLXDrawable	w;
	unsigned int	width = (unsigned int)SvUV(ST(0));
	unsigned int	height = (unsigned int)SvUV(ST(1));

	if (items < 4)
	    d = dpy;
	else {
	    d = INT2PTR(void *,SvIV(ST(3)));
	}

	if (items < 3)
	    w = win;
	else {
	    w = INT2PTR(GLXDrawable,SvIV(ST(2)));
	}

	glpResizeWindow(width, height, w, d);
    }
    XSRETURN_EMPTY;
}


XS(XS_OpenGL_glXSwapBuffers); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glXSwapBuffers)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glXSwapBuffers", "w=win, d=dpy");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	d;
	GLXDrawable	w;

	if (items < 2)
	    d = dpy;
	else {
	    d = INT2PTR(void *,SvIV(ST(1)));
	}

	if (items < 1)
	    w = win;
	else {
	    w = INT2PTR(GLXDrawable,SvIV(ST(0)));
	}
#line 644 "pogl_gl_top.xs"
	{
	    glXSwapBuffers(d,w);
	}
#line 928 "pogl_gl_top.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_OpenGL_XPending); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_XPending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::XPending", "d=dpy");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	d;
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    d = dpy;
	else {
	    d = INT2PTR(void *,SvIV(ST(0)));
	}
#line 653 "pogl_gl_top.xs"
	{
		RETVAL = XPending(d);
	}
#line 959 "pogl_gl_top.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenGL_glpXNextEvent); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpXNextEvent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpXNextEvent", "d=dpy");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	d;

	if (items < 1)
	    d = dpy;
	else {
	    d = INT2PTR(void *,SvIV(ST(0)));
	}
#line 664 "pogl_gl_top.xs"
	{
		XEvent event;
		char buf[10];
		KeySym ks;
		XNextEvent(d,&event);
		switch(event.type) {
			case ConfigureNotify:
				EXTEND(sp,3);
				PUSHs(sv_2mortal(newSViv(event.type)));
				PUSHs(sv_2mortal(newSViv(event.xconfigure.width)));
				PUSHs(sv_2mortal(newSViv(event.xconfigure.height)));				
				break;
			case KeyPress:
			case KeyRelease:
				EXTEND(sp,2);
				PUSHs(sv_2mortal(newSViv(event.type)));
				XLookupString(&event.xkey,buf,sizeof(buf),&ks,0);
				buf[0]=(char)ks;buf[1]='\0';
				PUSHs(sv_2mortal(newSVpv(buf,1)));
				break;
			case ButtonPress:
			case ButtonRelease:
				EXTEND(sp,7);
				PUSHs(sv_2mortal(newSViv(event.type)));
				PUSHs(sv_2mortal(newSViv(event.xbutton.button)));
				PUSHs(sv_2mortal(newSViv(event.xbutton.x)));
				PUSHs(sv_2mortal(newSViv(event.xbutton.y)));
				PUSHs(sv_2mortal(newSViv(event.xbutton.x_root)));
				PUSHs(sv_2mortal(newSViv(event.xbutton.y_root)));
				PUSHs(sv_2mortal(newSViv(event.xbutton.state)));
				break;
			case MotionNotify:
				EXTEND(sp,4);
				PUSHs(sv_2mortal(newSViv(event.type)));
				PUSHs(sv_2mortal(newSViv(event.xmotion.state)));
				PUSHs(sv_2mortal(newSViv(event.xmotion.x)));
				PUSHs(sv_2mortal(newSViv(event.xmotion.y)));
				break;
			case Expose:
			default:
				EXTEND(sp,1);
				PUSHs(sv_2mortal(newSViv(event.type)));
				break;
		}
	}
#line 1033 "pogl_gl_top.c"
	PUTBACK;
	return;
    }
}


XS(XS_OpenGL_glpXQueryPointer); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpXQueryPointer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpXQueryPointer", "w=win, d=dpy");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	d;
	GLXDrawable	w;

	if (items < 2)
	    d = dpy;
	else {
	    d = INT2PTR(void *,SvIV(ST(1)));
	}

	if (items < 1)
	    w = win;
	else {
	    w = INT2PTR(GLXDrawable,SvIV(ST(0)));
	}
#line 716 "pogl_gl_top.xs"
	{
		int x,y,rx,ry;
		Window r,c;
		unsigned int m;
		XQueryPointer(d,w,&r,&c,&rx,&ry,&x,&y,&m);
		EXTEND(sp,3);
		PUSHs(sv_2mortal(newSViv(x)));
		PUSHs(sv_2mortal(newSViv(y)));
		PUSHs(sv_2mortal(newSViv(m)));
	}
#line 1079 "pogl_gl_top.c"
	PUTBACK;
	return;
    }
}

#endif /* defined HAVE_GLpc */

XS(XS_OpenGL_glpSetDebug); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpSetDebug)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpSetDebug", "flag");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flag = (int)SvIV(ST(0));
#line 735 "pogl_gl_top.xs"
        {
        debug = flag;
        }
#line 1104 "pogl_gl_top.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_OpenGL_glpReadTex); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpReadTex)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpReadTex", "file");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	file = (char *)SvPV_nolen(ST(0));
#line 745 "pogl_gl_top.xs"
	{
		GLsizei w,h;
		int d,i;
		char buf[250];
		unsigned char *image;
		FILE *fp;
		char *ret;

		fp=fopen(file,"r");

		if(!fp)	croak("couldn't open file %s",file);

		ret = fgets(buf,250,fp);		/* P3 */

		if (buf[0] != 'P' || buf[1] != '3')
			croak("Format is not P3 in file %s",file);

		ret = fgets(buf,250,fp);

		while (buf[0] == '#' && fgets(buf,250,fp));	/* Empty */

		if (2 != sscanf(buf,"%d%d",&w,&h))
			croak("couldn't read image size from file %s",file);
		if (1 != fscanf(fp,"%d",&d))
			croak("couldn't read image depth from file %s",file);
		if(d != 255)
			croak("image depth != 255 in file %s unsupported",file);
		if(w>10000 || h>10000)
			croak("suspicious size w=%d d=%d in file %s", w, d, file);

		New(1431, image, w*h*3, unsigned char);

		for(i=0;i<w*h*3;i++) {
			int v;

			if (1 != fscanf(fp,"%d",&v)) {
				Safefree(image);
				croak("Error reading number #%d of %d from file %s", i, w*h*3,file);
			}

			image[i]=(unsigned char) v;
		}

		fclose(fp);

		glTexImage2D(GL_TEXTURE_2D, 0, 3, w,h, 
			0, GL_RGB, GL_UNSIGNED_BYTE,image);
	}
#line 1172 "pogl_gl_top.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_OpenGL_glpHasGLUT); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpHasGLUT)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpHasGLUT", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 798 "pogl_gl_top.xs"
	{
#if defined(HAVE_GLUT) || defined(HAVE_FREEGLUT)
		RETVAL = 1;
#else
		RETVAL = 0;
#endif /* defined HAVE_GLUT or HAVE_FREEGLUT */
	}
#line 1200 "pogl_gl_top.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_OpenGL_glpHasGPGPU); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenGL_glpHasGPGPU)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "OpenGL::glpHasGPGPU", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 813 "pogl_gl_top.xs"
		RETVAL = gpgpu_size();
#line 1223 "pogl_gl_top.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif /* End IN_POGL_GLX_XS */
#ifdef __cplusplus
extern "C"
#endif
XS(boot_OpenGL__GL__Top); /* prototype to pass -Wmissing-prototypes */
XS(boot_OpenGL__GL__Top)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("OpenGL::_have_gl", XS_OpenGL__have_gl, file);
        newXS("OpenGL::_have_glu", XS_OpenGL__have_glu, file);
        newXS("OpenGL::_have_glut", XS_OpenGL__have_glut, file);
        newXS("OpenGL::_have_freeglut", XS_OpenGL__have_freeglut, file);
        newXS("OpenGL::_have_glx", XS_OpenGL__have_glx, file);
        newXS("OpenGL::_have_glp", XS_OpenGL__have_glp, file);
#if XSubPPtmpAAAA
        newXS("OpenGL::morphPM", XS_OpenGL_morphPM, file);
#endif
#if XSubPPtmpAAAB
        newXS("OpenGL::__had_dbuffer_hack", XS_OpenGL___had_dbuffer_hack, file);
#if XSubPPtmpAAAC
        newXS("OpenGL::glpcOpenWindow", XS_OpenGL_glpcOpenWindow, file);
        newXS("OpenGL::glpRasterFont", XS_OpenGL_glpRasterFont, file);
        newXS("OpenGL::glpPrintString", XS_OpenGL_glpPrintString, file);
        newXS("OpenGL::glpDisplay", XS_OpenGL_glpDisplay, file);
        newXS("OpenGL::glpMoveResizeWindow", XS_OpenGL_glpMoveResizeWindow, file);
        newXS("OpenGL::glpMoveWindow", XS_OpenGL_glpMoveWindow, file);
        newXS("OpenGL::glpResizeWindow", XS_OpenGL_glpResizeWindow, file);
        newXS("OpenGL::glXSwapBuffers", XS_OpenGL_glXSwapBuffers, file);
        newXS("OpenGL::XPending", XS_OpenGL_XPending, file);
        newXS("OpenGL::glpXNextEvent", XS_OpenGL_glpXNextEvent, file);
        newXS("OpenGL::glpXQueryPointer", XS_OpenGL_glpXQueryPointer, file);
#endif
        newXS("OpenGL::glpSetDebug", XS_OpenGL_glpSetDebug, file);
        newXS("OpenGL::glpReadTex", XS_OpenGL_glpReadTex, file);
        newXS("OpenGL::glpHasGLUT", XS_OpenGL_glpHasGLUT, file);
        newXS("OpenGL::glpHasGPGPU", XS_OpenGL_glpHasGPGPU, file);
#endif

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#if XSubPPtmpAAAC
#endif
#endif
#line 1285 "pogl_gl_top.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

